{
 *************************************************************************
                      VertRuler component
                        ver 1.0 Freeware
                           for Delphi 5 ( not tested on other)
                      Author Tomasz Grecznaik ( Gryku)
                        mail: gryku@poland.com
                          Wroclaw 14.12.2000
                       Wroclaw University of Technology
  *************************************************************************
}
unit VertRuler;

interface
uses
   Windows, Messages, SysUtils, Classes, Graphics, Controls, ExtCtrls,StdCtrls,Forms;


type
   TPlaceVert=(plLeft,plRight);

   TVertRuler = class(TPanel)
private
    FOnPaint: TNotifyEvent;
    FUsePanelStyle: Boolean;
    FscalaColor:Tcolor;
    FscalaFactor:Integer;
    FscalaFontSize:integer;
    FscalaOffset:integer;
    FScalaTextIncrement:real;
    FScalaShowText:boolean;
    FScalaEdge:TplaceVert;
    FShowUnit:boolean;
    FTextUnit:string;
protected
   procedure Paint; override;
   procedure SetUsePanelStyle(Value: Boolean);
   procedure Paintscala(obj:TObject);
   procedure SetscalaFactor(value : integer);
   procedure SetscalaColor(value :Tcolor);
   procedure SetScalaFontSize(value:integer);
   procedure SetscalaOffset(value:integer);
   procedure SetscalaTextIncrement(value:real);
   procedure SetScalaShowText(value:boolean);
   procedure SetScalaEdge(value:TPlaceVert);
   procedure SetShowUnit(value:boolean);
   Procedure SetTextUnit(value:string);
   procedure PaintUnit;
   property Canvas;
   procedure Clear;
   procedure PaintBorder;
   property UsePanelStyle: Boolean read FUsePanelStyle write SetUsePanelStyle default true;
public
   constructor create(Owner:TComponent);override;
published
    property ScalaShowText:boolean read FScalaShowText write SetScalaShowText default true;
    property ScalaFactor:Integer read FscalaFactor write SetscalaFactor default 2;
    property OnPaint: TNotifyEvent read FOnPaint write FOnPaint;
    property ScalaColor:Tcolor read FscalaColor write SetscalaColor default clblack;
    property ScalaFontSize:integer read FscalaFontSize write SetscalaFontSize ;
    property ScalaOffset:Integer read FscalaOffset write SetscalaOffset default 100;
    property ScalaTextIncrement:real read FscalaTextIncrement write SetScalaTextIncrement ;
    property ScalaEdgePos:tplaceVert read Fscalaedge write SetscalaEdge default plLeft;
    property ShowUnit:boolean read FShowUnit write SetShowUnit default true;
    property TextUnit:string read FTextUnit write SetTextUnit ;
end;

procedure Register;

implementation

procedure TvertRuler.Clear;
var r:Trect;
begin
r.Top:=1;
r.left:=1;
r.Right:=width-1;
r.Bottom:=height-1;
canvas.brush.Color:=cl3dlight;
canvas.brush.style:=bssolid;
canvas.fillrect(r);
end;

constructor TVertRuler.create(Owner: TComponent);
begin
inherited create(Owner);
parent:=owner as TWinControl;
usepanelstyle:=true;
top:=122;
left:=30;
height:=300;
width:=25;
FscalaFactor:=2;
FscalaFontSize:=6;
FscalaOffset:=100;
FScalaTextIncrement:=1;
FscalaShowtext:=true;
FscalaEdge:=plLeft;
FShowUnit:=true;
Ftextunit:='mm';
onpaint:=paintscala;
end;

procedure TVertRuler.Paint;
begin
    if FUsePanelStyle then inherited Paint;
    if Assigned(FOnPaint) then FOnPaint(Self);
end;

procedure TVertRuler.PaintBorder;
begin
canvas.Pen.Color:=clBtnHighLight;
canvas.moveto(0,0);
canvas.lineto(width,0);
canvas.Pen.color:=clBtnShadow;
canvas.MoveTo(0,height-1);
canvas.lineto(width,height-1);
end;

procedure TVertRuler.Paintscala(obj:TObject);
var i,j:integer;
     scala:integer;
     x:integer;
     x2:integer;
     y,y1:integer;
     s,k:integer;
begin
clear;
canvas.Pen.color:=FscalaColor;
canvas.Font.Name:='arial';
canvas.Font.size:=FscalaFontSize;
scala:=10*FscalaFactor;
if FscalaEdge=plleft then
   begin
    y:=1; y1:=10; s:=1;k:=1;
    end
      else
    begin
    y:=width-2; y1:=width-10; s:=-1;k:=-10;
    end;

  for i:=0 to ((height-FscalaOffset) div scala) do
    begin
      x:=(i*scala);
      canvas.moveto(y,x+FscalaOffset);
      canvas.LineTo(y1,x+FscalaOffset);

      if FScalaShowText then
      canvas.TextOut(y1+k,x-4+FscalaOffset,floattostr(i*FScalaTextIncrement));

      canvas.moveto(y,x+(scala div 2)+FscalaOffset);
      canvas.LineTo(y1-(3*s),x+(scala div 2)+FscalaOffset);

      for j:=0 to 10 do
        begin
          x2:=(j*FscalaFactor);
          canvas.moveto(y,x+x2+FscalaOffset);
          canvas.lineto(y1-(5*s),x+x2+FscalaOffset);
        end;
    end;
  for i:=0 downto -Fscalaoffset+1 do
    begin
      x:=(i*scala);
      canvas.moveto(y,x+FscalaOffset);
      canvas.LineTo(y1,x+FscalaOffset);

      if FScalaShowText then
      canvas.TextOut(y1+k,x-4+FscalaOffset,floattostr(i*FScalaTextIncrement));

      canvas.moveto(y,x+FscalaOffset+(scala div 2));
      canvas.LineTo(y1-(3*s),x+FscalaOffset+(scala div 2));

      for j:=0 to 10 do
        begin
          x2:=(j*FscalaFactor);
          canvas.moveto(y,x+x2+FscalaOffset);
          canvas.lineto(y1-(5*s),x+x2+FscalaOffset);
        end;
    end;
if FshowUnit then
    canvas.textout(y1+k,height-canvas.textheight(FtextUnit)-4,FTextUnit);

paintborder;
end;

procedure TVertRuler.PaintUnit;
var w:integer;
begin

end;

procedure TVertRuler.SetscalaColor(value: Tcolor);
begin
FscalaColor:=value;
Paintscala(self);
end;

procedure TVertRuler.SetScalaEdge(value: TPlaceVert);
begin
FscalaEdge:=value;
Paintscala(self);
end;

procedure TVertRuler.SetscalaFactor(value:integer);
begin
FscalaFactor:=value;
Paintscala(self);
end;


procedure TVertRuler.SetScalaFontSize(value: integer);
begin
Fscalafontsize:=value;
paintscala(self);
end;

procedure TVertRuler.SetscalaOffset(value: integer);
begin
FscalaOffset:=value;
Paintscala(self);
end;

procedure TVertRuler.SetScalaShowText(value: boolean);
begin
FScalaShowText:=value;
PaintScala(self);
end;

procedure TVertRuler.SetScalaTextIncrement(value: real);
begin
FScalaTextIncrement:=value;
Paintscala(self);
end;

procedure TVertRuler.SetShowUnit;
begin
FShowunit:=value;
PaintScala(self);
end;

procedure TVertRuler.SetTextUnit;
begin
FTextUnit:=Value;
PaintScala(self);
end;

procedure TVertRuler.SetUsePanelStyle(Value: Boolean);
begin
   FUsePanelStyle := Value;
   RePaint;
end;

procedure Register;
begin
   RegisterComponents('Freeware', [TVertRuler]);
end;

end.


 